#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

#include "Tree.h"


//Creates a random tree with 5 to 8 nodes 
//and random content in each node
void treeGenerator(NodePointer *tree)
{
    int nNodes;
    DataStruct data;
    char dataName[10], intString[4];
    nNodes = rand()%4+5;
    for(int i = 0; i < nNodes; ++i)
    {
        sprintf(intString, "%d", i);
        data.key = i;
        data.value = rand()/(float)(RAND_MAX/10);
        strcpy(dataName, "Nó ");
        strcat(dataName, intString);
        data.name = (char*) malloc(sizeof(char)*strlen(dataName));
        strcpy(data.name, dataName);
        insert(tree, data);
    }
}

//Create a random tree, print it, than print in order
//Print it again, and then pre order
//Print it again, and then post order
int main()
{
    NodePointer tree = NULL;
    srand(time(NULL));
    treeGenerator(&tree);
	
    print2D(tree);
    printf("\n\n");
    printf("In Order: \n");
    inOrder(tree);
    printf("\n\n");
    print2D(tree);
    printf("\n\n");
    printf("Pre Order: \n");
    preOrder(tree);
    printf("\n\n");
    print2D(tree);
    printf("\n\n");
    printf("Post Order: \n");
    postOrder(tree);
    printf("\n\n");
    return 0;
}
