#include <stdlib.h>
#include <stdio.h>
#define COUNT 10

//Data of a node
typedef struct Data
{
    int key;
    float value;
    char* name;
    //Other data type for each node
} DataStruct;

typedef struct Node TreeNode;

typedef TreeNode* NodePointer;

//A node contains the data it must hold and pointer to children
struct Node{
    DataStruct data;
    NodePointer leftChild, rightChild;
};


void insert(NodePointer *root, DataStruct data);
void inOrder(NodePointer node);
void preOrder(NodePointer node);
void postOrder(NodePointer node);
int countNodes(NodePointer node);
void print2D(NodePointer root);
